image: abreto/docker-ci

stages:
  - build
  - deploy

variables:
  STACK_NAME: gitlab-runner
  IP: noip

build:
  stage: build
  variables:
    DOCKER_TLS_CERTDIR: /certs
  services:
    - docker:dind
  before_script:
    - eval "$REGISTRY_LOGIN"
  script:
    - docker-compose pull --ignore-pull-failures
    - docker-compose build --parallel
    - if [ "$CI_COMMIT_BRANCH" = "master" ]; then docker-compose push; fi

deploy:
  stage: deploy
  before_script:
    - . "$DEPLOY_LIB"
    - eval "$REGISTRY_LOGIN"
  script:
    - docker-compose pull
    - docker stack deploy -c docker-compose.yml --with-registry-auth "$STACK_NAME"
    - docker stack services "$STACK_NAME"
  rules:
    - if: '$IP == "noip"'
      when: manual
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: on_success
